﻿Imports System.Data
Imports System.Linq
Imports System.Configuration
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim query As String = "SELECT Id, Location, Preference FROM HolidayLocations ORDER BY Preference"
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        gvLocations.DataSource = dt
                        gvLocations.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub UpdatePreference(sender As Object, e As EventArgs)
        Dim locationIds As Integer() = (From p In Request.Form("LocationId").Split(",") _
                                       Select Integer.Parse(p)).ToArray()
        Dim preference As Integer = 1
        For Each locationId As Integer In locationIds
            Me.UpdatePreference(locationId, preference)
            preference += 1
        Next

        Response.Redirect(Request.Url.AbsoluteUri)
    End Sub

    Private Sub UpdatePreference(locationId As Integer, preference As Integer)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("UPDATE HolidayLocations SET Preference = @Preference WHERE Id = @Id")
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Parameters.AddWithValue("@Id", locationId)
                    cmd.Parameters.AddWithValue("@Preference", preference)
                    cmd.Connection = con
                    con.Open()
                    cmd.ExecuteNonQuery()
                    con.Close()
                End Using
            End Using
        End Using
    End Sub
End Class
